<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>uWeaver UI - API documentation : Source: chart/CartesianCoordinate.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link href="styles/bootstrap.css" rel="stylesheet">
    <link href="styles/docs.css" rel="stylesheet">
    <link href="styles/bootstrap-custom.css" rel="stylesheet">
    <link href="http://netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
    <script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <header class="header navbar navbar-inverse">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="brand" href="#"><strong>uWeaver UI</strong> API documentation</a>
        </div>
      </div>
    </header>

    <div class="container-fluid">
      <div class="row-fluid">
          <div class="span4">
              <h2><a href="index.html">Index</a></h2><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Modules</li><li><a href="module-datetime.html">datetime</a></li>
<li><a href="module-dom.html">dom</a></li>
<li><a href="module-environment.html">environment</a></li>
<li><a href="module-formatter.html">formatter</a></li>
<li><a href="module-i18n.html">i18n</a></li>
<li><a href="module-lang.html">lang</a></li>
<li><a href="module-net.html">net</a></li>
<li><a href="module-number.html">number</a></li>
<li><a href="module-uweaver.html">uweaver</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Classes</li><li><a href="Activities.html"><i class="icon-shield" style="color: #0186d1"></i> Activities</a></li><li><a href="Activity.html"><i class="icon-shield" style="color: #0186d1"></i> Activity</a></li><li><a href="Applet.html"><i class="icon-shield" style="color: #0186d1"></i> Applet</a></li><li><a href="BaseObject.html"><i class="icon-shield" style="color: #0186d1"></i> BaseObject</a></li><li><a href="Button.html"><i class="icon-shield" style="color: #0186d1"></i> Button</a></li><li><a href="CartesianChart.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianChart</a></li><li><a href="CartesianCoordinate.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianCoordinate</a></li><li><a href="Collection.html"><i class="icon-shield" style="color: #0186d1"></i> Collection</a></li><li><a href="Container.html"><i class="icon-shield" style="color: #0186d1"></i> Container</a></li><li><a href="Form.html"><i class="icon-shield" style="color: #0186d1"></i> Form</a></li><li><a href="Gadget.html"><i class="icon-shield" style="color: #0186d1"></i> Gadget</a></li><li><a href="Grid.html"><i class="icon-shield" style="color: #0186d1"></i> Grid</a></li><li><a href="Icon.html"><i class="icon-shield" style="color: #0186d1"></i> Icon</a></li><li><a href="Inputbox.html"><i class="icon-shield" style="color: #0186d1"></i> Inputbox</a></li><li><a href="Item.html"><i class="icon-shield" style="color: #0186d1"></i> Item</a></li><li><a href="Json.html"><i class="icon-shield" style="color: #0186d1"></i> Json</a></li><li><a href="Logger.html"><i class="icon-shield" style="color: #0186d1"></i> Logger</a></li><li><a href="MDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> MDIApplet</a></li><li><a href="Memory.html"><i class="icon-shield" style="color: #0186d1"></i> Memory</a></li><li><a href="Menu.html"><i class="icon-shield" style="color: #0186d1"></i> Menu</a></li><li><a href="Model.html"><i class="icon-shield" style="color: #0186d1"></i> Model</a></li><li><a href="Pagination.html"><i class="icon-shield" style="color: #0186d1"></i> Pagination</a></li><li><a href="Panel.html"><i class="icon-shield" style="color: #0186d1"></i> Panel</a></li><li><a href="Popup.html"><i class="icon-shield" style="color: #0186d1"></i> Popup</a></li><li><a href="Proxy.html"><i class="icon-shield" style="color: #0186d1"></i> Proxy</a></li><li><a href="Reader.html"><i class="icon-shield" style="color: #0186d1"></i> Reader</a></li><li><a href="Site.html"><i class="icon-shield" style="color: #0186d1"></i> Site</a></li><li><a href="Sites.html"><i class="icon-shield" style="color: #0186d1"></i> Sites</a></li><li><a href="Store.html"><i class="icon-shield" style="color: #0186d1"></i> Store</a></li><li><a href="TabPanel.html"><i class="icon-shield" style="color: #0186d1"></i> TabPanel</a></li><li><a href="TDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> TDIApplet</a></li><li><a href="Testbench.html"><i class="icon-shield" style="color: #0186d1"></i> Testbench</a></li><li><a href="Testlet.html"><i class="icon-shield" style="color: #0186d1"></i> Testlet</a></li><li><a href="Toolbox.html"><i class="icon-shield" style="color: #0186d1"></i> Toolbox</a></li><li><a href="Trigger.html"><i class="icon-shield" style="color: #0186d1"></i> Trigger</a></li><li><a href="Triggers.html"><i class="icon-shield" style="color: #0186d1"></i> Triggers</a></li><li><a href="User.html"><i class="icon-shield" style="color: #0186d1"></i> User</a></li><li><a href="Users.html"><i class="icon-shield" style="color: #0186d1"></i> Users</a></li><li><a href="Widget.html"><i class="icon-shield" style="color: #0186d1"></i> Widget</a></li><li><a href="WindowManager.html"><i class="icon-shield" style="color: #0186d1"></i> WindowManager</a></li><li><a href="Workbench.html"><i class="icon-shield" style="color: #0186d1"></i> Workbench</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Global</li><li><a href="global.html#$selector"><i class="icon-globe" style="color: black;"></i> $selector</a></li><li><a href="global.html#_anchors"><i class="icon-globe" style="color: black;"></i> _anchors</a></li><li><a href="global.html#_form"><i class="icon-globe" style="color: black;"></i> _form</a></li><li><a href="global.html#_interact"><i class="icon-globe" style="color: black;"></i> _interact</a></li><li><a href="global.html#_marker"><i class="icon-globe" style="color: black;"></i> _marker</a></li><li><a href="global.html#_tabPanel"><i class="icon-globe" style="color: black;"></i> _tabPanel</a></li><li><a href="global.html#_total"><i class="icon-globe" style="color: black;"></i> _total</a></li><li><a href="global.html#browse"><i class="icon-globe" style="color: black;"></i> browse</a></li><li><a href="global.html#draggable"><i class="icon-globe" style="color: black;"></i> draggable</a></li><li><a href="global.html#events"><i class="icon-globe" style="color: black;"></i> events</a></li><li><a href="global.html#initialize"><i class="icon-globe" style="color: black;"></i> initialize</a></li><li><a href="global.html#layout"><i class="icon-globe" style="color: black;"></i> layout</a></li><li><a href="global.html#logger"><i class="icon-globe" style="color: black;"></i> logger</a></li><li><a href="global.html#login"><i class="icon-globe" style="color: black;"></i> login</a></li><li><a href="global.html#model"><i class="icon-globe" style="color: black;"></i> model</a></li><li><a href="global.html#onDragstart"><i class="icon-globe" style="color: black;"></i> onDragstart</a></li><li><a href="global.html#onTabsActivate"><i class="icon-globe" style="color: black;"></i> onTabsActivate</a></li><li><a href="global.html#onTaskSelect"><i class="icon-globe" style="color: black;"></i> onTaskSelect</a></li><li><a href="global.html#perform"><i class="icon-globe" style="color: black;"></i> perform</a></li><li><a href="global.html#prepare"><i class="icon-globe" style="color: black;"></i> prepare</a></li><li><a href="global.html#requirejs"><i class="icon-globe" style="color: black;"></i> requirejs</a></li><li><a href="global.html#showMenu"><i class="icon-globe" style="color: black;"></i> showMenu</a></li><li><a href="global.html#start"><i class="icon-globe" style="color: black;"></i> start</a></li><li><a href="global.html#toUrl"><i class="icon-globe" style="color: black;"></i> toUrl</a></li><li><a href="global.html#url"><i class="icon-globe" style="color: black;"></i> url</a></li><li><a href="global.html#validate"><i class="icon-globe" style="color: black;"></i> validate</a></li></ul></div>
          </div>

          <div class="span8">
              <h1 class="page-header">Source: chart/CartesianCoordinate.js</h1>
              


    
    <section>
        <article>
            <pre class="prettyprint source"><code>/**
 * This document is a part of the source code and related artifacts
 * for uWeaver, an open source application development framework for
 * Enterprise Application Software.
 *
 *      http://www.uweaver.org
 *
 * Copyright 2016 Jason Lin
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

define(['underscore', 'jquery', 'd3', 'ss', 'uweaver/lang',
    'uweaver/data/Collection'], function(_, $, d3, ss, lang, Collection) {

    var declare = lang.declare;
    var Base = null;

    /**
     * A CartesianCoordinate is a Cartesian coordinate system.
     *
     * ##### JavaScript
     *
     *     var OrderCubes = declare(Collection, {
     *        resource: 'orderCubes',
     *        orderDate: function(options) {
     *            this.sync('orderDate', this, options).then(function(response) {
     *                var items = this.parse(response);
     *                this.reset(items);
     *            }, this);
     *        },
     *        area: function(options) {
     *            this.sync('area', this, options).then(function(response) {
     *                var items = this.parse(response);
     *                this.reset(items);
     *            }, this);
     *        }
     *     });

     *     var cubes = new OrderCubes();
     *
     *     // Generate a temporal scatter chart.
     *
     *     cubes.orderDate({async: false});
     *
     *     var temporalScatterChart = new CartesianChart({
     *        data: cubes,
     *        el: '[name=TemporalScatterCanvas]',
     *        //define the x and y-axis configuration.
     *        axes: [{
     *            type: 'number',
     *            position: 'left',
     *            subtype: 'integer',
     *            unit: 'USD'
     *        }, {
     *            type: 'date',
     *            position: 'bottom',
     *            title: 'Order Date',
     *            ticks: 'days',
     *            pattern: 'MM/dd'
     *        }],
     *        //set legend configuration
     *        legend: {
     *            docked: 'right'
     *        },
     *        //define the actual data series.
     *        series: [{
     *            type: 'scatter',
     *            xField: 'orderDate',
     *            yField: 'amount',
     *            axis: 'left',
     *            title: 'Revenue'
     *        }],
     *        title: "Daily Revenue &amp; Cost"
     *     }).render();
     *
     *     temporalScatterChart.grid('left').grid('bottom').interpolate('Revenue').trend(0);
     *
     *     // Generate a categorical bar chart.
     *
     *     cubes.area({async: false});
     *
     *     var categoricalBarChart = new CartesianChart({
     *        data: cubes,
     *        el: '[name=CategoricalBarCanvas]',
     *        //define the x and y-axis configuration.
     *        axes: [{
     *            type: 'number',
     *            position: 'left',
     *            subtype: 'integer',
     *            unit: 'USD'
     *        }, {
     *            position: 'bottom',
     *            title: 'Area'
     *        }],
     *        //set legend configuration
     *        legend: {
     *            docked: 'right'
     *        },
     *        //define the actual data series.
     *        series: [{
     *            type: 'bar',
     *            xField: 'area',
     *            yField: 'amount',
     *            axis: 'left',
     *            title: 'Revenue'
     *        }],
     *        width: 700, height: 400,
     *        title: "Revenue &amp; Cost by Area"
     *     }).render();
     *
     *     categoricalBarChart.grid('left');
     *
     * ##### HTML
     *     &lt;svg name="TemporalScatterCanvas" style="width:700px;height:400px;">
     *     &lt;/svg>
     *
     *     &lt;svg style="width:700px;height:400px;">
     *          &lt;g name="CategoricalBarCanvas">
     *          &lt;/g>
     *     &lt;/svg>
     *
     * #### JSON
     *     URL: orderCubes/orderDate
     *     Response:
     *     {
     *       "status" : 200,
     *       "items" : [{
     *           "amount": 1200,
     *           "cost": 800,
     *           "orderDate": "2015-03-04T00:00:00.000+0800"
     *       }, {
     *           "amount": 1500,
     *           "cost": 900,
     *           "orderDate": "2015-03-05T00:00:00.000+0800"
     *       }, {
     *           "amount": 800,
     *           "cost": 480,
     *           "orderDate": "2015-03-06T00:00:00.000+0800"
     *       }, {
     *           "amount": 2200,
     *           "cost": 1300,
     *           "orderDate": "2015-03-9T00:00:00.000+0800"
     *       }, {
     *           "amount": 800,
     *           "cost": 500,
     *           "orderDate": "2015-03-10T00:00:00.000+0800"
     *       }, {
     *           "amount": 1200,
     *           "cost": 860,
     *           "orderDate": "2015-03-11T00:00:00.000+0800"
     *       }, {
     *           "amount": 2300,
     *           "cost": 1430,
     *           "orderDate": "2015-03-12T00:00:00.000+0800"
     *       }]
     *     }
     *
     *     URL: orderCubes/area
     *     Response:
     *     {
     *       "status" : 200,
     *       "items" : [{
     *         "amount": 1200,
     *         "cost": 1000,
     *         "area": "north"
     *       }, {
     *           "amount": 800,
     *           "cost": 750,
     *           "area": "south"
     *       }, {
     *           "amount": 2200,
     *           "cost": 1800,
     *           "area": "east"
     *       }, {
     *           "amount": 2300,
     *           "cost": 1830,
     *           "area": "west"
     *       }]
     *     }
     *
     * ##### Events:
     * + 'transition' - [data()]{@link CartesianCoordinate#data}
     *
     * @constructor CartesianCoordinate
     * @extends Widget
     * @author  Jason Lin
     * @since   1.0
     * @param {Object} [config] - A map of configuration to pass to the constructor.
     * @param {Collection} [config.data=new Collection()] - A collection to specify the models to display.
     */
    function initialize(config) {
        Base.prototype.initialize.apply(this, arguments);

        var defaults = {};
        var cfg = this.cfg();

        _.defaults(cfg, defaults);

        this._scales = {};

        (cfg.data) ? this.data(cfg.data) : this.data(new Collection());
        this.width(cfg.width); this.height(cfg.height);
    }

    /**
     * Create the coordinate system.
     *
     * @private
     */
    function coordinate() {
        var cfg = this.cfg();
        var dataset = this._dataset;

        var margin = this._margin;
        var width = this.width() - margin.left - margin.right, height = this.height() - margin.top - margin.bottom;
        var canvas = this.canvas();
        var countSeriesByType =_.countBy(cfg.series, function(series){
            return series.type;
        });
        var numberOfBars = countSeriesByType['bar'];

        canvas.append('g').attr('name', 'axes');
        _.each(cfg.axes, function(cfg) {
            var type = cfg.type, position = cfg.position;
            var pattern = cfg.pattern;
            var domain = cfg.range || [];
            var scale, axis;
            var range;
            var tickSize;
            var ticks = cfg.ticks || 10;
            var fields = [];
            _.each(this.cfg().series, function(series) {
                if(position==='bottom') {
                    fields.push(series.xField)
                } else if(position===series.axis) {
                    fields.push(series.yField);
                }
            });


            if(type==='date' || type==='number') {
                if(domain[0]==undefined) {
                    domain[0] = d3.min(dataset, function(item){
                        var value;
                        _.each(fields, function(field) {
                            var itemValue = !_.isArray(field) ? item.get(field) : _.reduce(field, function(memo, f) {
                                return memo + item.get(f);
                            }, 0);
                            value = (value) ? Math.min(value, itemValue) : itemValue;
                        });
                        if(type==='date') {
                            value = new Date(value);
                        }
                        return value;
                    });
                    if(type==='number' &amp;&amp; position!=='bottom') {
                        domain[0] = Math.min(0, domain[0]);
                    }
                }
                if(domain[1]==undefined) {
                    domain[1] = d3.max(dataset, function(item){
                        var value;
                        _.each(fields, function(field) {
                            var itemValue = !_.isArray(field) ? item.get(field) : _.reduce(field, function(memo, f) {
                                return memo + item.get(f);
                            }, 0);
                            value = (value) ? Math.max(value, itemValue) : itemValue;
                        });
                        if(type==='date') {
                            value = new Date(value);
                        }
                        return value;
                    });
                }
            } else {
                if(domain.length===0) {
                    domain = _.map(dataset, function(item) {
                        return item.get(fields[0]);
                    });
                }
            }

            if(position==='left'||position==='right') {
                range = [height, 0];
                tickSize = (position==='left') ? width * -1 : width;
            } else {
                range = [0, width];
                tickSize = height;
            }

            var extended = false;
            if(type==='date') {
                cfg.ticks = analyzeTicks(domain);
                if(cfg.ticks==='days') {
                    ticks = d3.time.days;
                    pattern = 'MM/dd';
                    if(numberOfBars>0 &amp;&amp; position==='bottom') {
                        domain[0] = domain[0].setDate(domain[0].getDate()-1);
                        domain[1] = domain[1].setDate(domain[1].getDate()+1);
                        extended = true;
                    }

                } else if(cfg.ticks==='weeks') {
                    ticks = d3.time.weeks;
                    pattern = 'MM/dd';
                    if(numberOfBars>0 &amp;&amp; position==='bottom') {
                        domain[0] = domain[0].setDate(domain[0].getDate()-7);
                        domain[1] = domain[1].setDate(domain[1].getDate()+7);
                        extended = true;
                    }
                } else if(cfg.ticks==='months') {
                    ticks = d3.time.months;
                    pattern = 'yyyy/MM';
                    if(numberOfBars>0 &amp;&amp; position==='bottom') {
                        domain[0] = domain[0].setMonth(domain[0].getMonth()-1);
                        domain[1] = domain[1].setMonth(domain[1].getMonth()+1);
                        extended = true;
                    }
                } else if(cfg.ticks==='years') {
                    ticks = d3.time.years;
                    pattern = 'yyyy';
                    if(numberOfBars>0 &amp;&amp; position==='bottom') {
                        domain[0] = domain[0].setYear(domain[0].getYear()-1);
                        domain[1] = domain[1].setYear(domain[1].getYear()+1);
                        extended = true;
                    }
                }
                scale = d3.time.scale().domain(domain).range(range);
            } else if(type==='number') {
                if(numberOfBars>0 &amp;&amp; position==='bottom') {
                    domain[0] = domain[0] - 1;
                    domain[1] = domain[1] + 1;
                    extended = true;
                }
                scale = d3.scale.linear().domain(domain).range(range);
            } else {
                scale = d3.scale.ordinal().domain(domain).rangeBands(range, 0.4);
            }
            if(position==='bottom' &amp;&amp; type==='number') {
                ticks = dataset.length;
            }
            axis = d3.svg.axis().scale(scale).orient(position).tickSize(tickSize).ticks(ticks);

            axis.tickFormat(function(value, i) {
                return formatter.format(value, {pattern: pattern});
            });

            axis.tickPadding(10);
            canvas.select('g[name=axes]').append('g').attr({'name': position, 'font-size': '12px'}).call(axis);

            this._scales[position] = scale;

            if(extended) {
                var $tickTexts = this.$('[name=axes] [name=' + position +'] g.tick text');
                $tickTexts.first().css('display', 'none');
                $tickTexts.last().css('display', 'none');
            }
        }, this);

        canvas.selectAll('path.domain').attr({'fill': 'none', 'stroke': 'black'});
    }

    function analyzeTicks(domain) {
        if(domain[0].getYear()!==domain[1].getYear()) {
            return 'years';
        } else if(domain[0].getMonth()!==domain[1].getMonth()) {
            return 'months';
        } else if(domain[0].getDate()!==domain[1].getDate()) {
            return 'days';
        } else if(domain[0].getHours()!==domain[1].getHours()) {
            return 'hours';
        } else {
            return 'minutes';
        }
    }

    /**
     * Plot the series on the chart.
     *
     * @private
     */
    function plot() {
        var cfg = this.cfg();
        var dataset = this._dataset;
        var canvas = this.canvas();
        var margin = this._margin;
        var width = this.width() - margin.left - margin.right, height = this.height() - margin.top - margin.bottom;
        var countSeriesByType =_.countBy(cfg.series, function(series){
            return series.type;
        });
        var numberOfBars = countSeriesByType['bar'];

        _.each(cfg.series, function(cfg, i) {
            var xField = cfg.xField, yField = cfg.yField;
            var xScale = this._scales['bottom'], yScale = this._scales[cfg.axis];
            var type = cfg.type;
            var title = (cfg.title || i);

            if(type==='bar') {
                var rangeBand;

                if(xScale.rangeBand) {
                    rangeBand = xScale.rangeBand();
                } else {
                    var range = xScale.range();
                    rangeBand = Math.abs(range[1] - range[0]) / (dataset.length) * 0.6;
                }

                var fields = _.isArray(yField) ? yField : [yField];
                var titles = _.isArray(titles) ? titles : [titles];
                var yOffset = {};

                _.each(fields, function(field, j) {
                    titles[j] || (titles[j] = _.uniqueId());
                    canvas.append('g').attr('name', titles[j])
                        .selectAll('rect')
                        .data(dataset).enter().append('rect').attr({fill: this.color(i+j)})
                        .attr('width', rangeBand / numberOfBars)
                        .attr('x', function(item){
                            var value = item[xField] ? item[xField]() : item.get(xField);
                            var x;
                            if(xScale.rangeBand) {
                                x = xScale(value);
                            } else {
                                x = xScale(value) - rangeBand / 2;
                            }
                            if(numberOfBars>1) {
                                x = x + (rangeBand / numberOfBars) * (i);
                            }

                            return x;
                        }).attr('height', function(item) {
                        return height - yScale(item.get(field));
                    }).attr('y', function(item) {
                        var xValue = item[xField] ? item[xField]() : item.get(xField);
                        yOffset[xValue] || (yOffset[xValue] = 0);
                        var value = item[field] ? item[field]() : item.get(field);
                        var y = yScale(value) - yOffset[xValue];
                        yOffset[xValue] = yOffset[xValue] + height - yScale(item.get(field));

                        return y;
                    });

                }, this);

            } else {
                cfg.marker = {
                    type: 'rect',
                    width: 8,
                    height: 8,
                    fill: this.color(i)
                };
                canvas.append('g').attr('name', title)
                    .selectAll(cfg.marker.type)
                    .data(dataset).enter().append(cfg.marker.type).attr(cfg.marker)
                    .attr('x', function(item){
                        var value = item[xField] ? item[xField]() : item.get(xField);
                        var x = xScale(value) - cfg.marker.width / 2;

                        if(xScale.rangeBand) {
                            x = x + xScale.rangeBand() / 2
                        }
                        return x
                    }).attr('y', function(item) {
                    var value = item[yField] ? item[yField]() : item.get(yField);
                    return yScale(value) - cfg.marker.height / 2;
                });
            }
        }, this);
    }

    /**
     *
     * Draw the grid lines.
     *
     * @private
     * @param position
     * @param options
     * @returns {grid}
     */
    function grid(position, options) {
        options || (options = {});
        var defaults = {
            stroke: 'grey',
            'stroke-width': '0.5px'
        };
        _.defaults(options, defaults);

        var canvas = this.canvas();

        canvas.selectAll('[name=' + position + '] g.tick line').attr(options);

        return this;
    }

    /**
     *
     * Draw the interpolate lines.
     *
     * @private
     * @param index
     * @param options
     * @returns {interpolate}
     */
    function interpolate(index, options) {
        var cfg = this.cfg();

        _.isNumber(index) || (index = _.findIndex(cfg.series, function(series) {return series.title===index}));

        options || (options = {});
        var defaults = {
            type: 'linear',
            fill: 'none',
            stroke: this.color(index),
            'stroke-width': '2px'
        };
        _.defaults(options, defaults);

        var canvas = this.canvas();


        var type = options.type;
        var series = cfg.series[index];
        var xField = series.xField, yField = series.yField;
        var dataset = this._dataset;
        var xScale = this._scales['bottom']; yScale = this._scales[series.axis];

        var line = d3.svg.line()
            .x(function(item) {
                var value = item[xField] ? item[xField]() : item.get(xField);
                var x = xScale(value);

                if(xScale.rangeBand) {
                    x = x + xScale.rangeBand() / 2
                }
                return x
            })
            .y(function(item) {
                var value = item[yField] ? item[yField]() : item.get(yField);
                return  yScale(value);
            }).interpolate(type);

        canvas.append('path').attr('d', line(dataset)).attr(options);

        return this;
    }

    /**
     * Draw the trend line.
     *
     * @private
     * @param index
     * @param options
     * @returns {trend}
     */
    function trend(index, options) {
        options || (options = {});
        var defaults = {
            fill: 'none',
            stroke: 'green',
            'stroke-width': '2px',
            'stroke-dasharray': '10, 10'
        };
        _.defaults(options, defaults);

        var canvas = this.canvas();
        var cfg = this.cfg();
        var series = _.isNumber(index) ? cfg.series[index] : _.findWhere(cfg.series, {title: index});
        var xField = series.xField, yField = series.yField;
        var dataset = this._dataset;
        var xScale = this._scales['bottom']; yScale = this._scales[series.axis];

        // create a trend line.
        var data = _.map(dataset, function(item) {
            var xValue = item[xField] ? item[xField]() : item.get(xField);
            var yValue = item[yField] ? item[yField]() : item.get(yField);

            return [xScale(xValue), yScale(yValue)];
        });
        var lr = ss.linearRegressionLine(ss.linearRegression(data));

        var trend = d3.svg.line()
            .x(function(item) {
                var value = item[xField] ? item[xField]() : item.get(xField);
                return xScale(value);
            })
            .y(function(item) {

                var value = item[xField] ? item[xField]() : item.get(xField);
                return lr(xScale(value));
            });

        canvas.append('path').attr('d', trend(dataset)).attr(options);

        return this;
    }


    /**
     * Get or set the data.
     *
     * ##### Events:
     * + 'transition' - triggered after a new collection is bound. event.data => the collection.
     *
     * @memberof CartesianChart#
     * @param {Collection} items - the data.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {Boolean} [options.silent=false] - A false value will prevent the events from being triggered.
     * @param {Boolean} [options.render=true] - A false value will prevent the chart from being rendered.
     * @returns {CartesianChart} this
     */
    function data(items, options) {
        if(!items) return this._data;

        options || (options = {});

        var defaults = {
            render: true
        };

        _.defaults(options, defaults);

        if(this._data) this.stopListening(this._data);

        this._data = items;

        this._dataset = items.toArray();

        this.listenTo(this._data, "update", _.bind(onItemsUpdate, this));

        options.render &amp;&amp; this.render();

        var event = {
            context: this,
            source: this,
            data: items
        };

        (options.silent) || this.trigger('transition', event);

        return this;
    }

    function onItemsUpdate() {
        this.refresh();
    }

    function refresh() {

    }

    function canvas() {
        return this._canvas;
    }

    /**
     * @override
     */
    function width(value) {
        if(!value) return this._width;

        this._width = value;
        this.$el.width(value);
    }

    /**
     * @override
     */
    function height(value) {
        if(!value) return this._height;

        this._height = value;
        this.$el.height(value);
    }

    function color(index) {
        return this._color(index)
    }

    var props = {
        _data: undefined,
        _dataset: undefined,
        _scales: undefined,
        _canvas: undefined,
        _margin: undefined,
        _measurement: undefined,
        _width: undefined,
        _height: undefined,
        _color: undefined

    };

    var CartesianCoordinate = declare(Base, {
        initialize: initialize
    }, props);

    return CartesianCoordinate;

});</code></pre>
        </article>
    </section>




          </div>
      </div>

        <br clear="both">

      <footer>
        Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.3.2</a> on Wed Mar 30 2016 09:12:36 GMT+0800 (CST)
        <br>
      </footer>
      <script> prettyPrint(); </script>
    </div>
  </body>
</html>
